from sqlalchemy import Column, Integer,String,DateTime,func
from app import db
from sqlalchemy.orm import relationship
from sqlalchemy.ext.declarative import declarative_base
import bcrypt
Base: declarative_base = db.Model
class User(Base):
    __tablename__ = "users"
    id = Column(Integer, primary_key=True)
    role_id = Column(Integer, nullable=False)
    customer_id = Column(Integer, nullable=False)
    site_id = Column(Integer, nullable=False)
    zone_id = Column(String, nullable=False)
    preference = Column(String, nullable=False)
    room_id = Column(Integer, nullable=False)
    device_id = Column(Integer, nullable=False)
    full_name = Column(String, nullable=False)
    logo_id = Column(Integer, nullable=False, default = 0)
    email = Column(String, nullable=False)
    password = Column(String, nullable=False)
    created_at = Column(DateTime(timezone=True), default=func.now())
    updated_at = Column(DateTime(timezone=True), default=func.now())

    logs_timelines = relationship("LogsTimeline", back_populates="user")

    def __init__(self, full_name, site_id, zone_id, device_id, logo_id, room_id, email, password, role_id,
                 customer_id, preference):
        self.full_name = full_name
        self.email = email
        self.role_id = role_id
        self.customer_id = customer_id
        self.site_id = site_id
        self.zone_id = zone_id
        self.room_id = room_id
        self.device_id =device_id
        self.preference = preference
        self.logo_id = logo_id
        self.password = bcrypt.hashpw(password.encode('utf-8'), bcrypt.gensalt()).decode('utf-8')